"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ng_bootstrap_1 = require("@ng-bootstrap/ng-bootstrap");
var org_interface_1 = require("../../../common/interface/org.interface");
var post_interface_1 = require("../../../common/interface/post.interface");
var PostManagementComponent = /** @class */ (function () {
    function PostManagementComponent(orgInterface, modalService, postInterface) {
        this.orgInterface = orgInterface;
        this.modalService = modalService;
        this.postInterface = postInterface;
        this.mockData = []; // 模拟数据
        this.treeOptions = {
            iconCls: {
                expand: 'tree-icon-expand',
                file: 'tree-icon-file',
                folder: 'tree-icon-folder'
            },
        }; // 树节点操作按钮配置
        this.treeSearch = {
            text: '',
            searching: false,
            result: [],
        };
    }
    PostManagementComponent.prototype.ngOnInit = function () {
        this.getOrgTreeData();
    };
    // 获取组织树数据
    PostManagementComponent.prototype.getOrgTreeData = function () {
        var _this = this;
        this.orgInterface.getOrgTreeData({
            id: 1
        }).subscribe(function (res) {
            _this.mockData = res['result'];
        }, function (err) {
            alert(JSON.stringify(err));
        });
    };
    // 节点点击事件
    // todo
    PostManagementComponent.prototype.nodeClick = function (nodeData) {
        this.tree.selectTreeNode(nodeData);
        this.selectOrgData = nodeData;
        this.changeCurrentOrgData(nodeData);
    };
    // 切换组织节点
    PostManagementComponent.prototype.changeCurrentOrgData = function (data) {
        var _this = this;
        this.currentOrgData = null;
        setTimeout(function () {
            _this.currentOrgData = data;
        }, 1);
    };
    // 模糊搜索组织名称
    PostManagementComponent.prototype.searchTreeNode = function (ev) {
        this.resetTreeSearch();
        if (!this.treeSearch.text) {
            return;
        }
        this.treeSearch.searching = true;
        this.treeSearch.result = this.tree.fuzzySearchNodesByKey(this.treeSearch.text, 'orgName');
        this.tree.lighthightNodes(this.treeSearch.result);
        this.tree.expandNodes(this.treeSearch.result);
        this.treeSearch.searching = false;
    };
    PostManagementComponent.prototype.resetTreeSearch = function () {
        this.tree.removeLighthightNodes(this.treeSearch.result);
        this.treeSearch.searching = false;
        this.treeSearch.result = [];
    };
    __decorate([
        core_1.ViewChild('tree'),
        __metadata("design:type", Object)
    ], PostManagementComponent.prototype, "tree", void 0);
    PostManagementComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            templateUrl: './post.management.component.html',
            styleUrls: ['./post.management.component.css']
        }),
        __metadata("design:paramtypes", [org_interface_1.OrgInterface,
            ng_bootstrap_1.NgbModal,
            post_interface_1.PostInterface])
    ], PostManagementComponent);
    return PostManagementComponent;
}());
exports.PostManagementComponent = PostManagementComponent;
//# sourceMappingURL=post.management.component.js.map