var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ComponentFactoryResolver, ViewChild, ViewContainerRef, HostListener, ElementRef, Injector, ApplicationRef } from '@angular/core';
import { Router } from '@angular/router';
let DrawComponent = class DrawComponent {
    constructor(router, resolver, elementRef, injector, applicationRef) {
        this.router = router;
        this.resolver = resolver;
        this.elementRef = elementRef;
        this.injector = injector;
        this.applicationRef = applicationRef;
        this.show = false;
        this.firstInit = true;
    }
    onClick(event) {
        //第一次点击无效
        if (this.firstInit) {
            this.firstInit = false;
            return;
        }
        if (!this.elementRef.nativeElement.contains(event.target)) {
            let result = this.componentRef.instance.beforeLeave();
            if (typeof (result) == "boolean" && result) {
                this.closeComponent();
            }
            if (typeof (result) == "object" && result.then) {
                result.then(r => {
                    if (r) {
                        this.closeComponent();
                    }
                });
            }
        }
    }
    closeComponent() {
        this.show = false;
        setTimeout(() => {
            this.container.clear();
            this.closeResolve('close');
        }, 500);
    }
    ngAfterViewInit() {
        setTimeout(() => {
            this.show = true;
        });
    }
    ngOnDestroy() {
        this.container.clear();
    }
    ngDoCheck() {
    }
    ngOnInit() {
        this.container.clear();
        this.componentRef = this.container.createComponent(this.resolver.resolveComponentFactory(this.injectComponet));
        this.instance = this.componentRef.instance;
        this.instance.data = this.data;
    }
    ngOnChanges(changes) {
    }
};
__decorate([
    ViewChild("componentContainer", { read: ViewContainerRef }),
    __metadata("design:type", ViewContainerRef)
], DrawComponent.prototype, "container", void 0);
__decorate([
    HostListener('document:click', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], DrawComponent.prototype, "onClick", null);
DrawComponent = __decorate([
    Component({
        selector: "drawer",
        template: `
   <div class="draw-container" [ngClass]="{'show':show}">
    <ng-template #componentContainer></ng-template>
   </div>
  `,
        styles: [
            '.draw-container{' +
                'width: 66%;' +
                'position: absolute;' +
                'height: 100vh;' +
                'right: 0;' +
                'background-color: white;' +
                'max-width: 0;' +
                'transition: max-width 0.5s ease-in,color 0.3s ease-out;' +
                'box-shadow: -2px 0px 15px 0px #888888;' +
                'z-index: 1;' +
                'background: #fcfcfc;' +
                'padding: 30px;' +
                'overflow-x: hidden;' +
                'overflow-y: auto}',
            '.draw-container.show{max-width:100%;}'
        ]
    }),
    __metadata("design:paramtypes", [Router, ComponentFactoryResolver,
        ElementRef, Injector, ApplicationRef])
], DrawComponent);
export { DrawComponent };
//# sourceMappingURL=draw.component.js.map