var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
import { Router, NavigationStart, NavigationEnd, NavigationCancel, NavigationError, RoutesRecognized } from '@angular/router';
let LeftMenuComponent = class LeftMenuComponent {
    constructor(router) {
        this.router = router;
        this.menus = [
            {
                title: "资源管理1111",
                show: true,
                mainRouter: '/home/resource',
                src: './assets/img/ziyuanguanli.png',
                srcSelect: '/assets/img/ziyuanguanli-select.jpg',
                submenus: [
                    {
                        title: "物理机管理",
                        router: 'psMachine',
                    },
                    {
                        title: "云主机管理",
                        router: 'cloudMachine',
                    },
                    {
                        title: "租户管理",
                        router: 'tenants',
                    }
                ]
            },
            {
                title: "告警与监控",
                show: false,
                mainRouter: '/home/warn',
                src: '/assets/img/jiankong.jpg',
                srcSelect: '/assets/img/jiankong-select.png',
                submenus: [
                    {
                        title: "监控管理",
                        router: 'watching/psmachine',
                        matchRouter: ['watching/cloudmachine']
                    },
                    {
                        title: "告警管理",
                        router: 'warnning/notprocess',
                        matchRouter: ['warnning/processed']
                    }
                ]
            },
            {
                title: "工作流",
                show: false,
                src: '/assets/img/gongzuliu.jpg',
                srcSelect: '/assets/img/gongzuliu-select.png',
                mainRouter: '/home/workflow',
                submenus: [
                    {
                        title: "订单管理",
                        router: 'order',
                    },
                    {
                        title: "审批管理",
                        router: 'approval',
                    },
                    {
                        title: "工作流管理",
                        router: 'procedure',
                    }
                ]
            }
        ];
        this.routerlistener = router.events.subscribe(event => {
            if (event instanceof NavigationStart) {
                //不处理
            }
            else if (event instanceof NavigationEnd) {
                let url = event.url;
                let foundMenu, foundSubMenu;
                for (let menu of this.menus) {
                    for (let submenu of menu.submenus) {
                        if (menu.mainRouter + '/' + submenu.router == url) {
                            foundMenu = menu;
                            foundSubMenu = submenu;
                        }
                        if (foundMenu == null && foundSubMenu == null && submenu.matchRouter) {
                            for (let r of submenu.matchRouter) {
                                if (menu.mainRouter + '/' + r == url) {
                                    foundMenu = menu;
                                    foundSubMenu = submenu;
                                }
                            }
                        }
                        submenu.active = false;
                    }
                }
                if (foundMenu && foundSubMenu) {
                    foundMenu.show = true;
                    foundSubMenu.active = true;
                }
            }
            else if (event instanceof NavigationCancel) {
                //不处理
            }
            else if (event instanceof NavigationError) {
                //不处理
            }
            else if (event instanceof RoutesRecognized) {
                //不处理
            }
        });
    }
    ngOnDestroy() {
        if (this.routerlistener) {
            this.routerlistener.unsubscribe();
        }
    }
    menuClick(menu) {
        menu.show = !menu.show;
    }
    subMenuClick(menu, submenu) {
        this.router.navigate([menu.mainRouter + '/' + submenu.router]);
    }
};
LeftMenuComponent = __decorate([
    Component({
        selector: 'leftmenu',
        template: `<div class="menu-background">
    <div class="logo"></div>
    <div *ngFor="let menu of menus">
        <div class="main-title-container">
            <div class="main-title" (click)="menuClick(menu)" [ngClass]="{'menuFont':menu.show}">
                <div>
                    <img src="{{menu.src}}" style="margin-right: 10px;" *ngIf="!menu.show"/>
                    <img src="{{menu.srcSelect}}" style="margin-right: 10px;"  *ngIf="menu.show"/>
                </div>
                <span>{{menu.title}}</span>
                <div class="display-flex flex-end" style="flex: 1;padding-right: 20px;">
                    <div class="menu-pointer" [ngClass]="{'show':menu.show}"></div>
                </div>
            </div>
            <div class="sub-title-container" [ngClass]="{'show':menu.show}">
                <div *ngFor="let submenu of menu.submenus" class="sub-title" (click)="subMenuClick(menu,submenu)" [ngClass]="{'active':submenu.active}">
                    {{submenu.title}}
                </div>
            </div>
        </div>
    </div>
</div>`,
        styles: [
            '.menu-background{' +
                'width: 260px;' +
                'height: 100vh;' +
                'background: #433d61;' +
                'font: #a8b4c7;' +
                'padding-bottom: 10000px;' +
                'margin-bottom: -10000px}',
            '.logo{' +
                'width: 100%;' +
                'height: 160px;' +
                'text-align: center;' +
                'background-image: url(/assets/img/logo.jpg);' +
                'background-repeat: no-repeat;' +
                'background-position: center;}',
            '.main-title{' +
                'width: 100%;' +
                'cursor: pointer;' +
                'font-size: 16px;' +
                'color: #a8b4c7;' +
                'height: 50px;' +
                'line-height: 50px;' +
                'padding-left: 30px;' +
                'display: flex;}',
            '.sub-title-container{' +
                'max-height:0px;' +
                'overflow: hidden;' +
                'transition: max-height 0.5s ease-in,color 0.3s ease-out;' +
                'color: #a8b4c7;' +
                'font-size: 14px;' +
                'background-color: #302c47;' +
                'border-left: 6px solid #1ab394;}',
            '.sub-title-container.show{' +
                'max-height:200px;}',
            '.sub-title{' +
                'cursor: pointer;' +
                'height: 50px;' +
                'line-height: 50px;' +
                'padding-left: 60px;}',
            '.sub-title.active{' +
                'color: white;' +
                'font-weight: 800;}',
            '.main-title.menuFont{' +
                'color: white;' +
                'background-color: #302c47;' +
                'border-left: 6px solid #1ab394;' +
                'padding-left: 24px;}',
            '.menu-pointer{' +
                'background-image: url(/assets/img/arraw.png);' +
                'background-repeat: no-repeat;' +
                'background-position: center;' +
                'width: 20px;' +
                'height: 50px}',
            '.menu-pointer.show{' +
                'transform: rotate(270deg);}',
        ]
    }),
    __metadata("design:paramtypes", [Router])
], LeftMenuComponent);
export { LeftMenuComponent };
//# sourceMappingURL=leftmenu.component.js.map