var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
let PaginationComponent = class PaginationComponent {
    constructor() {
        this.showAfterDot = false;
        this.showBeforeDot = false;
        this.pageSize = 10;
        this.nowPage = 1;
        this.nowPageChange = new EventEmitter();
        this.paginationEvent = new EventEmitter();
        this.showList = [];
    }
    ngOnInit() {
        this.draw();
    }
    draw() {
        this.showList = [];
        this.showBeforeDot = false;
        this.showAfterDot = false;
        if (this.total == 0)
            return;
        this.maxPage = Math.ceil(this.total / this.pageSize);
        if (this.nowPage <= 3) {
            if (this.maxPage <= 6) {
                for (let i = 2; i <= this.maxPage - 1; i++) {
                    this.showList.push(i);
                }
            }
            if (this.maxPage > 6) {
                for (let i = 2; i <= 5; i++) {
                    this.showList.push(i);
                }
                this.showAfterDot = true;
            }
        }
        else {
            if (this.nowPage - 2 > 1) {
                this.showList.push(this.nowPage - 2);
                if (this.nowPage - 2 > 2) {
                    this.showBeforeDot = true;
                }
            }
            if (this.nowPage - 1 > 1) {
                this.showList.push(this.nowPage - 1);
            }
            if (this.nowPage != this.maxPage) {
                this.showList.push(this.nowPage);
            }
            if (this.nowPage + 1 < this.maxPage) {
                this.showList.push(this.nowPage + 1);
            }
            if (this.nowPage + 2 < this.maxPage) {
                this.showList.push(this.nowPage + 2);
                if (this.nowPage + 2 < this.maxPage - 1) {
                    this.showAfterDot = true;
                }
            }
        }
    }
    jumpPage(page) {
        if (page == null) {
            this.nowPage = this.jump;
        }
        else {
            if (page == 'before') {
                if (this.nowPage == 1) {
                    return;
                }
                this.nowPage = this.nowPage - 1;
            }
            else if (page == 'after') {
                if (this.nowPage == this.maxPage) {
                    return;
                }
                this.nowPage = this.nowPage + 1;
            }
            else {
                this.nowPage = page;
            }
        }
        if (this.nowPage > this.maxPage) {
            this.nowPage = this.maxPage;
        }
        this.draw();
        this.nowPageChange.emit(this.nowPage);
        this.paginationEvent.emit();
    }
    pressInput(event) {
        if (event.key == 'Enter') {
            this.jumpPage();
            this.jump = null;
        }
    }
    ngOnChanges(changes) {
        if (!changes.total.firstChange) {
            this.draw();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number)
], PaginationComponent.prototype, "total", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], PaginationComponent.prototype, "pageSize", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], PaginationComponent.prototype, "nowPage", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], PaginationComponent.prototype, "nowPageChange", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], PaginationComponent.prototype, "paginationEvent", void 0);
PaginationComponent = __decorate([
    Component({
        selector: 'pagination',
        template: `
  <div class="display-flex width-100 flex-end" *ngIf="total!=0">

    <div style="font-size: 12px;color: #666666">
        共{{total}}条
    </div>
    <div class="display-flex" style="margin-left:20px">
        <div class="select-box left" (click)="jumpPage('before')" [ngClass]="{'cursor-pointer':nowPage!=1}"></div>
        <div class="cursor-pointer number" style="margin-left:5px" (click)="jumpPage(1)" [ngClass]="{'selet':nowPage==1}">1</div>
        <div *ngIf="showBeforeDot" style="margin-left:10px">...</div>
        <div class="cursor-pointer number" style="margin-left:10px" *ngFor="let c of showList" (click)="jumpPage(c)" [ngClass]="{'selet':nowPage==c}">{{c}}</div>
        <div *ngIf="showAfterDot" style="margin-left:10px">...</div>
        <div class="cursor-pointer number" *ngIf="maxPage!=1" style="margin-left:10px" (click)="jumpPage(maxPage)" [ngClass]="{'selet':nowPage==maxPage}">{{maxPage}}</div>
        <div class="select-box right" style="margin-left:5px" (click)="jumpPage('after')" [ngClass]="{'cursor-pointer':nowPage!=maxPage}"></div>
    </div>
    <div style="margin-left:20px;font-size: 12px;color: #666666">
        跳转至
        <input [(ngModel)]="jump" type="text" class="jump-input" (keypress)="pressInput($event)"> 页
    </div>
</div>
  `,
        styles: [
            '.jump-input{' +
                'height: 17px;' +
                'width: 17px;' +
                'min-width: 30px;}',
            '.select-box{' +
                'display: flex;' +
                'justify-content: center;}',
            '.selet{' +
                'background-color: #e2e8ed;' +
                'width: 24px;' +
                'height: 24px;' +
                'border-radius: 3px;}',
            '.number{' +
                'width: 24px;' +
                'height: 24px;' +
                'display: flex;' +
                'justify-content: center;' +
                'align-items: center;' +
                'font-size: 12px;' +
                'color: #666666}',
            '.left{' +
                'background-image: url(/assets/img/leftPage.png);' +
                'background-repeat: no-repeat;' +
                'background-position: center;' +
                'width: 24px;' +
                'height: 24px}',
            '.right{' +
                'background-image: url(/assets/img/rightPage.png);' +
                'background-repeat: no-repeat;' +
                'background-position: center;' +
                'width: 24px;' +
                'height: 24px}',
        ]
    }),
    __metadata("design:paramtypes", [])
], PaginationComponent);
export { PaginationComponent };
//# sourceMappingURL=pagination.component.js.map