var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, ViewContainerRef, ComponentFactoryResolver } from '@angular/core';
import { Router } from '@angular/router';
let TabComponent = class TabComponent {
    constructor(resolver, router) {
        this.resolver = resolver;
        this.router = router;
        this.tabChangeEvent = new EventEmitter();
    }
    set tabDatas(v) {
        this._tabDatas = v;
        this.init();
    }
    get tabDatas() {
        return this._tabDatas;
    }
    ngOnInit() {
    }
    init() {
        if (this.tabDatas == null && this.tabDatas.length == 0) {
            this.dyComponent.clear();
            return;
        }
        this.dyComponent.clear();
        for (let tab of this.tabDatas) {
            if (tab.select) {
                this.nowSelectTab = tab;
            }
        }
        if (this.nowSelectTab == null) {
            this.nowSelectTab = this.tabDatas[0];
        }
        if (this.nowSelectTab.component) {
            let component = this.resolver.resolveComponentFactory(this.nowSelectTab.component);
            this.ref = this.dyComponent.createComponent(component);
            if (this.nowSelectTab.data) {
                let instance = this.ref.instance;
                instance.data = this.nowSelectTab.data;
            }
        }
        if (this.nowSelectTab.url) {
            let params = this.nowSelectTab.params == null ? {} : this.nowSelectTab.params;
            this.router.navigate([this.nowSelectTab.url], { queryParams: params });
        }
    }
    /*  ngOnChanges(changes: SimpleChanges) {
        if (changes.tabDatas && !changes.tabDatas.firstChange) {
          this.init();
        }
      }*/
    changeTab(tab) {
        for (let d of this.tabDatas) {
            d.select = false;
        }
        tab.select = true;
        this.nowSelectTab = tab;
        this.init();
        this.tabChangeEvent.emit(tab);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], TabComponent.prototype, "tabDatas", null);
__decorate([
    Output(),
    __metadata("design:type", Object)
], TabComponent.prototype, "tabChangeEvent", void 0);
__decorate([
    ViewChild('dyComponent', { read: ViewContainerRef }),
    __metadata("design:type", ViewContainerRef)
], TabComponent.prototype, "dyComponent", void 0);
TabComponent = __decorate([
    Component({
        selector: 'dc-tab',
        template: `
  <div class="display-flex width-100 flex-direction-column">
    <div class="display-flex width-100 tabs">
        <div *ngFor="let d of tabDatas">
            <div class="title" (click)="changeTab(d)" [ngClass]="{'active':d.select}">
                <div *ngIf="d.icon" class="icon"><img src="{{d.icon}}"></div>
                <div>{{d.title}}</div>
                <i *ngIf="d.notify && d.notify>0" [ngStyle]="{'background-color':d.notifyColor}">{{d.notify}}</i>
            </div>
        </div>
    </div>
    <div #dyComponent class="width-100"></div>
  </div>`,
        styles: [
            '.tabs {' +
                'padding: 15px 20px 0;' +
                'border-bottom: solid 1px #d6d6d6}',
            '.tabs>div {' +
                'margin-right: 70px}',
            '.title {' +
                'cursor: pointer;' +
                'display: table;' +
                'position: relative;' +
                'bottom: 0;' +
                'font-size: 18px;' +
                'height: 36px;' +
                'color: #666;}',
            '.title.active {' +
                'font-weight: bold;' +
                'color: #333;' +
                'border-bottom: solid 2px #333;' +
                'bottom: -1px;}',
            '.title>div {' +
                'display: table-cell;' +
                'vertical-align: middle;}',
            '.title.active>div {' +
                'padding-bottom: 3px}',
            '.title>div.icon {' +
                'padding: 0 10px 5px 0}',
            '.title>i {' +
                'font-size: 10px;' +
                'font-weight: 400;' +
                'position: absolute;' +
                'left: calc(100% + 7px);' +
                'top: 10px;' +
                'display: block;' +
                'padding: 0 8px;' +
                'line-height: 14px;' +
                'height: 16px;' +
                'color: #fff;' +
                'border-radius: 10px;' +
                'font-style: normal}',
            '.title.active>i {' +
                '  top: 9px' +
                '}'
        ]
    }),
    __metadata("design:paramtypes", [ComponentFactoryResolver, Router])
], TabComponent);
export { TabComponent };
//# sourceMappingURL=tab.component.js.map